#ifndef KONTO_HH
#define KONTO_HH

//
// Klasse fuer ein Konto
//


#include <iostream.h>
#include <fstream.h>
#include "transaktion.hh"
#include "../misc/list.hh"
#include "acl.hh"


class TKonto
{
public:
  TKonto(int Nr, int Kunde);
  TKonto(ifstream &in);
  ~TKonto();
  TKonto( const TKonto& Kt );
  TKonto& TKonto::operator=(const TKonto &Konto) {
    // Selbstzuweisung abfangen
    if (this == &Konto) return *this;
    // Speicherplatz freigeben
    delete(Acl);
    delete(Aktionen);
    Acl = new TAcl(*Konto.getAcl());         
    Aktionen = new TList<TTransaktion>(*Konto.getAktionen());
    KontoStand=Konto.getKontoStand();
    KontoNr=Konto.getKontoNr();
    return *this;
  }

  // Zwei Konten sind gleich wenn die Kontonummer uebereinstimmt
  friend bool operator==( TKonto K, TKonto k) 
  { 
    return K.KontoNr == k.KontoNr ;}

  friend ostream& operator << ( ostream& os, TKonto &K )
  {
    os << "KONTO"             << endl 
       << K.getKontoNr()      << endl
       << K.getKontoStand()   << endl
       << *K.getAktionen() 
       << *K.Acl;
    return os;
  }

  int getKontoInhaber() const;
  void addAktion(const TTransaktion &A);
  double getKontoStand() const;
  int getKontoNr() const;
  TList<TPermission>& getPermission(int Kdnr) {return (Acl->getAccessData(Kdnr)).getPermissions();};
  TList<TTransaktion>* getAktionen()  const;
  TAcl* getAcl() const {return Acl;}

private:
  int KontoNr;
  TList<TTransaktion> *Aktionen;
  double KontoStand;
  TAcl *Acl;
};

#endif // KONTO_HH









