#include "kunde.hh"
#include <stdio.h>

//Implementierung von TKunde


//
// (NoName-) Standardkonstruktor
//
TKunde::TKunde()
{
	init(0,"NoName","NoPasswort","","","");
}

//
// DefaultKonstruktor
//
TKunde::TKunde(int nummer, 
			   const TString &name, 
			   const TString &passwort, 
			   const TString &onepw, 
			   const TString &pubkey)
{  
	init(nummer,name,passwort, onepw,"",pubkey);
}

// Laedt Kundendaten aus Filestream
TKunde::TKunde(ifstream &in)
{
	int Zeilenlaenge=1024; // Maximale Zeilenlaenge betraegt 1024
	char puffer[Zeilenlaenge]; 

	TString name;
	TString passwort;
	TString onepw;
	TString key;
	int nummer;
	for (int i=0; i<=4;i++)
    {
		in.getline(puffer,Zeilenlaenge);       
		switch (i)
		{
		case 0 :sscanf(puffer,"%d",  &nummer);           ;break; //1.Zeile
		case 1 :name.copyFrom(puffer,strlen(puffer));    ;break; //2.Zeile
		case 2 :passwort.copyFrom(puffer,strlen(puffer)) ;break; //3.Zeile
		case 3 :onepw.copyFrom(puffer,strlen(puffer))    ;break;//4.Zeile
		case 4 :key.copyFrom(puffer,strlen(puffer))      ;break;//5.Zeile  
		}
    }      
	init(nummer,name,passwort,onepw,"",key);  
}

//
// Copy-Konstruktor
// Erstellt Kopie eines Kunden
//
TKunde::TKunde( const TKunde& Kunde)
{
  
	init(Kunde.getNummer(),Kunde.getName(),Kunde.getPw(),
		 Kunde.getOnePw(),Kunde.getSessionPw(),Kunde.getPubKey());
}

//
// Initialisiert ein Object
//
void TKunde::init( int nummer, 
				   const TString &name, 
				   const TString &passwort,
				   const TString &onepw,
				   const TString &spw,
				   const TString &key)
{
	Nummer=nummer;
	Name = name;  
	Passwort = passwort;
	pubkey=key; 
	OnePw=onepw; 
	SessionPw=spw;  
}


//
// Zuweisungen der Form Kunde1=Kunde2
// sind nun moeglich
//
TKunde& TKunde:: operator = ( const TKunde &Kunde)
{
	// Selbstzuweisung abfangen
	if (this == &Kunde) return *this; 
	init(Kunde.getNummer(),Kunde.getName(),
		 Kunde.getPw(),Kunde.getOnePw(),Kunde.getSessionPw(),Kunde.getPubKey());
	return *this;	
}



//
// Liefert Namen des Kunden zurueck
//
TString TKunde::getName() const {return Name;}

//
// Liefert Passworte/Key des Kunden zurueck
//
TString TKunde::getPw() const {return Passwort;}

TString TKunde::getSessionPw() const {return SessionPw;}

TString TKunde::getOnePw() const { return OnePw;}

TString TKunde::getPubKey() const { return pubkey;}


//
// Liefert Nummer des Kunden zurueck
//
int TKunde::getNummer() const {return Nummer;}


//
// Aendert den Namen des Kunden
//
void TKunde::mutateName(const TString &name) { Name=name; }

//
// Aendert Passworte des Kunden
//
void TKunde::mutatePw(const TString &passwort) { Passwort = passwort; }

void TKunde::mutateSessionPw(const TString &passwort) { SessionPw=passwort;}

void TKunde::mutateOnePw(const TString &passwort) { OnePw=passwort;}

//
// Aendert Nummer des Kunden
//
void TKunde::mutateNummer(int nummer) { Nummer=nummer;}


//
// Gibt Speicher frei
//
TKunde::~TKunde()
{
}





