#ifndef TRANSAKTION_HH
#define TRANSAKTION_HH

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>
#include "../misc/TString.hh"

#define DauerAuftrag 1
#define BarEin 2
#define BarAus 3
#define Ueber  4


class TTransaktion
{
private:
	int Modus;
	double Betrag;
	int Source, Target;
	TString Zweck;
	int Status;

public:
	TTransaktion(int S, int T, double B, int M, const TString &Z);
	TTransaktion( const TTransaktion &T);
	TTransaktion(ifstream&);
	void init(int S, int T, double B, int M, const TString &Z);
	~TTransaktion();
	friend ostream& operator<<( ostream& os, TTransaktion &T )
	{
		os << "TRANSAKTION" << endl
		   << T.Source      << endl
		   << T.Target      << endl 
		   << T.Betrag      << endl;       
		switch(T.Modus)
		{
		case DauerAuftrag: os << "Dauerauftrag"   << endl; break;
		case BarEin:        os << "Bareinzahlung"  << endl; break;
		case BarAus:        os << "Barauszahlung"  << endl; break;
		case Ueber:         os << "Ueberweisung"   << endl; break;	
		default:            os << T.Modus           << endl; break;
		}
		os << T.Zweck << endl;    
		return os;
	}  

	TString toString() {    
		TString out;
		char str[1024];
		TString modus;
		switch(Modus)
		{
		case DauerAuftrag: modus.copyFrom("Dauerauftrag"); break;
		case BarEin:        modus.copyFrom("Bareinzahlung"); break;
		case BarAus:        modus.copyFrom("Barauszahlung"); break;
		case Ueber:         modus.copyFrom("Ueberweisung"); break;	      
		}
    
		sprintf(str,"Transfer:%d->%d, Betrag: %f, ",Source,Target,Betrag);
		out.copyFrom(str);
		out+=modus;out+=", Zweck:"; out+=Zweck;
		return out;
	}

	friend bool operator==( TTransaktion T, TTransaktion t) 
	{ 
		return ( T.getSource() == t.getSource()  &&
				 T.getTarget() == t.getTarget()  &&
				 T.getModus() == T.getModus()    &&
				 T.getZweck() == t.getZweck()    &&
				 T.getBetrag() == t.getBetrag() );
	}
  
  
	int getModus() const;
	double getBetrag() const;
	int getSource() const;
	int getTarget() const;
	TString getZweck() const;
	int getStatus() const;
	void mutateStatus(int S);
};

#endif // TRANSAKTION
