#ifndef CLIENT_HH
#define CLIENT_HH

// Datei client.hh

#include <qtabdlg.h>
#include <qapp.h>
#include "out.hh"
#include "../misc/msgdata.hh"
#include "../misc/message.hh"
#include "../misc/defines.hh"
#include <stdio.h>
#include <qsocknot.h> 

#include "../misc/socket.hh"
#include "../misc/TString.hh"

// encryption stuff
#include "../misc/idea.hh"
#include "../misc/md5.hh"
#include "../misc/TRSA.hh"
#include "../misc/TCoin.hh"



class TClient : public QTabDialog
{
    Q_OBJECT

private:       
    TMessage  msg;
    TIdea     idea;
    TMD5      md5;
    TRSA      rsaClient, rsaBank;
    int       rsaState,rsaNounce;

               
    int     reply;
    char   *msg_queue;
    bool    bIDEA;

    QSocketNotifier *sn,*storesn;
    TSocket          Socket;
    TSocket          storeSocket;

    // all coins and keys for DigiCash
    TCoin     *arrCoin[NO_OF_COIN], *pCoin;
    TBitArray  arrKey[NO_OF_COIN];
    int        usedCoin;
    uint       signCoinState;
    uint       transmitCoinState;
    int        serverPort;
    
public:
    TClient();
    ~TClient();

    Tout     *out;   
    MSGData  msgData;
    
  
	// loads modulus and private key from file
    bool loadKey ( int owner, int number, int type );

    //////////////////////////////////////////////////////////////
    //  
    // methods for DigiCash
    //  

    // create signed coin
    void signCoin ( const TString &socketMsg );

    void sendCoin(const TString &socketMsg);

    void connectServer(const char*,int);
    void sendmsg(TSocket&, const char* string=0);
    void send( TSocket&, const TString &msg );
    void rsaLogin(const TString &socketmsg);

  
    // Operation requested:   
    void connect_to_store(const char*,int);
    void login(const char*);
    void onelogin(const char*,int);
    void doRSA(int);
    void kstand();
    void kausz();
    void ueberw();
    void recht();
    void getcoin();
    void buy();    
    
 public slots:
    // we receive data from our socket (bank-server)
    void dataReceived(int);
};

extern TClient *Client;

#endif // CLIENT_HH
