//
//  Project   : libmisc
//  File      : TRandom.cc
//  Author    : Ronald Kriemann
//  Purpose   : class for a random numer generator
//

extern "C"
{
#include <stdlib.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
}

#include <iostream.h>

#include "defines.hh"
#include "TRandom.hh"

//
// some numbers wich are used in the RNG
//
#define m1  259200
#define ia1 7141
#define ic1 54773
#define rm1 3.8580247e-6

#define m2  134456
#define ia2 8121
#define ic2 28411
#define rm2 7.4373773e-6

#define m3  243000
#define ia3 4561
#define ic3 51349

//
// all static variables
//
// long    TRandom::ranIx1;
// long    TRandom::ranIx2;
// long    TRandom::ranIx3;
// double  TRandom::ranR[98];
bool    TRandom::bInitialized = FALSE;

//
// constructor
//
TRandom::TRandom ()
{
}

//
// init. random number generator
//
void
TRandom::seed ( int s )
{
//     int  j;
    int  r;
    int  fd;

    r = s;
    
    if (s == 0)
    {
#ifdef LINUX
        if ((fd = open( "/dev/random", O_RDONLY )) >= 0)
        {
            if (read( fd, (char*) &r, sizeof(r) ) < 0)
                r = int(getpid());
            
            close(fd);
        }// if
        else
            r = int(getpid());
#elif SUNOS
        r = int(getpid());
#endif
    }// if
    else
        r = s;

    srand( r );
    
    bInitialized = TRUE;

//     ranIx1 = (ic1-r) % m1;
//     ranIx1 = (ia1*ranIx1+ic1) % m1;
//     ranIx2 = ranIx1 % m2;
//     ranIx1 = (ia1*ranIx1+ic1) % m1;
//     ranIx3 = ranIx1 % m3;

//     for (j = 1; j <= 97; j++)
//     {
//         ranIx1  = (ia1*ranIx1+ic1) % m1;
//         ranIx2  = (ia2*ranIx2+ic2) % m2;
//         ranR[j] = (ranIx1+ranIx2*rm2)*rm1;
//     }// for 
}

//
// return random number
//
double
TRandom::random ( int s )
{
// 	double  ranRes;
// 	int     j;

	if (s != 0)
        seed( s );

    // if not init. do it with default value
    if (!bInitialized)
        seed( 0 );
//        seed( int(getpid()) );

    return double(rand()) / double(RAND_MAX);

// 	ranIx1 = (ia1*ranIx1+ic1) % m1;
// 	ranIx2 = (ia2*ranIx2+ic2) % m2;
// 	ranIx3 = (ia3*ranIx3+ic3) % m3;
	
// 	j = long(1 + (97*ranIx3) / m3);
// 	if ((j > 97) || (j < 1))
//     {
// 		cerr << "TRandom::random (int) : deteced strange situation" << endl;
//         j = 1;
//     }// if

// 	ranRes = ranR[j];
// 	ranR[j] = (ranIx1+ranIx2*rm2)*rm1;

// 	return ranRes;
}

//
// return random number in [a,b]
//
double
TRandom::random ( double a, double b, int s )
{
    return (a + ((b - a) * random( s )));
}

//  
// return integer random in [0,RAND_MAX)
//
long
TRandom::randomInt ( int s )
{
    return long( random( 0, RAND_MAX, s) );
}

//
// return ineger random in [a,b)
//
long
TRandom::randomInt ( long a, long b, int s )
{
    return long( random( a, b, s) );
}
