#ifndef __TSERVERSOCKET_HH
#define __TSERVERSOCKET_HH
//
//  Project   : libmisc
//  File      : TServerSocket.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for socket-based communication
//

extern "C" {
#include <netinet/in.h>
}

#include "TSocket.hh"

//
//
//
class TServerSocket : public TSocket
{
protected:
	// state of connection
	bool   bConnected;

	// struct for namespace and port
	struct sockaddr_in name;

public:
	// constructor
	TServerSocket ( uint port );
	
	// bind to socket
	virtual int bind ();

	// listen on socket
	virtual int listen ();

	// wait for client to connect and return new socket descr.
	virtual int accept ();

	// start whole communication
	virtual int startCommu ();
};

#endif  // TSERVERSOCKET_HH
