#ifndef __TIMER_HH
#define __TIMER_HH
//
//  Project   : libmisc
//  File      : timer.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for a timer (for speed tests)
//  Date      : 28.05.1997
//

#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

#include <iostream.h>

//
// the timer class
//
class TTimer 
{
protected:
	// the two timers
	struct rusage timerStart, timerEnd;

public:
	// constructor
	TTimer ();

	// sets the first timer
	void start ();

	// sets the second timer
	void stop ();
	
	// prints time between start and stop
	void stat ();

	// converts timeval to in sec and m_sec
	void convertTime( struct timeval start, struct timeval end,
					  long &sec, long &m_sec ) const;

	// stream output (only the time)
	friend ostream& operator<< ( ostream& os, const TTimer& timer );
};

#endif  // __TIMER_HH
