#ifndef __STORE_HH
#define __STORE_HH
//
//  Project   : besy
//  File      : store.hh
//  Author    : Christian Rost
//  Purpose   : class for a store
//  Date      : 
//  Changes   : 
//


#include "../misc/defines.hh"
#include "../misc/socket.hh"           // Socketcommunication

#include "../misc/msgdata.hh"          // Messagequeue Communication 
#include "../misc/message.hh"          // with banksrv


#include "../misc/TRSA.hh"
#include "../misc/TCoin.hh"

//
// this class opens a socket at given portnumber
// if a client has connected, the process will be forked
// and the methode run will be called
//
class TStore
{
protected:
  // Socket, wich the server is using
  TSocket Socket;  
    
  // msqid for the commu with the bankserver
  int  msqid;
  
  // are we a forked child
  bool bForked;

  TString   arrBlindMD5[NO_OF_ID][2];
  TString   arrR[NO_OF_ID][2];
  int       randList[NO_OF_ID];
  TBitArray arrID[NO_OF_ID];
  long     serialNo;
  TRSA    rsaBank;

public:
  // constructors
  TStore ( int portnumber );
  // destructors
  ~TStore ();
  
  // init the socket
  void init ();
  
  // wait for clients
  int wait ();
  
  // do your job
  int run (int nsd);
  
  // do parsing of messages
  bool parseMsg ( int nsd, TString plainMsg, MSGData &msgData, bool &bEndCommu );

  // sends the string to a socket
  bool sendln(int sd, const TString & string); 

  // sends a message to bank 
  // returns the reply of the bank
  TString sndMsg(TMessage &msg);


  // loads modulus and private key from file
  bool loadKey ( int owner, int number, int type );

  // Methoths for receiving coin-Information
  int transmitCoinState;
  void receiveCoin(int,const TString&);
 
};

#endif  // __STORE_HH
